package com.zt.plat.module.qms.resource.material.service;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceProductDO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductPageReqVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductRespVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductSaveReqVO;
import com.zt.plat.module.qms.resource.material.controller.vo.query.MaterialProductQueryVO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialProductDO;
import jakarta.validation.Valid;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 物料大类 Service 接口
 *
 * @author 后台管理
 */
public interface MaterialProductService {

    /**
     * 新增分类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    MaterialProductRespVO saveMaterialCategory(@Valid MaterialProductSaveReqVO createReqVO);

    /**
     * 获取分类树
     *
     * @return 树列表
     */
    List<MaterialProductRespVO> getMaterialCategoryTree();

    /**
     * 创建物料大类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    MaterialProductRespVO saveMaterialProduct(@Valid MaterialProductSaveReqVO createReqVO);

    /**
     * 更新物料大类
     *
     * @param updateReqVO 更新信息
     */
    void updateMaterialProduct(@Valid MaterialProductSaveReqVO updateReqVO);

    /**
     * 删除物料大类
     *
     * @param id 编号
     */
    void deleteMaterialProduct(Long id);

    /**
    * 批量删除物料大类
    *
    * @param ids 编号
    */
    void deleteMaterialProductListByIds(List<Long> ids);

    /**
     * 获得物料大类
     *
     * @param id 编号
     * @return 物料大类
     */
    MaterialProductDO getMaterialProduct(Long id);

    /**
     * 获得物料大类分页
     *
     * @param pageReqVO 分页查询
     * @return 物料大类分页
     */
    PageResult<MaterialProductDO> getMaterialProductPage(MaterialProductPageReqVO pageReqVO);

    /**
     * 获得物料大类详情
     *
     * @param id 编号
     * @return 物料大类
     */
    MaterialProductDO getMaterialProductInfo(Long id);

    /**
     * 获得物料分类和大类
     *
     * @param queryVO 查询参数
     * @return 列表
     */
    List<MaterialProductRespVO> getCategoryAndData(MaterialProductQueryVO queryVO);

    /**
     * 获得物料大类的库存分页信息
     *
     * @param pageReqVO 分页查询
     * @return 物料大类分页
     */
    PageResult<MaterialProductRespVO> getMaterialInventoryPage(@Valid MaterialProductPageReqVO pageReqVO);

    /**
     * 获取id在 idPath中的全部数据
     *
     * @param pdtId id
     * @return 物料数据
     */
    List<MaterialProductDO> getMaterialProductsByLikeIdPath(Long pdtId);

    /**
     * 根据ids获取大类数据
     *
     * @param pdtIds id
     * @return 物料数据
     */
    List<MaterialProductDO> getListByIds(List<Long> pdtIds);

    /**
     * 更新物料大类库存预警等级
     *
     * @param pdtIds ids
     */
    void updateMaterialProductAlarmLevel(List<Long> pdtIds);

    /**
     * 获取物料大类详情
     *
     * @param id id
     * @return 物料数据
     */
    MaterialProductRespVO getMaterialProductInfoWithFiles(Long id);

    /**
     * 获取物料大类库存数量
     *
     * @param mtrlIds 大类ids
     * @return 物料数据
     */
    Map<Long, Long> getStockQuantityByPdtIds(List<Long> mtrlIds);

    /**
     * 获取物料大类库存数量
     *
     * @param mtrlIds 大类ids
     * @param warehouseIds 仓库ids
     * @return 物料数据
     */
    Map<Long, Long> getStockQuantityByPdtIds(List<Long> mtrlIds, List<Long> warehouseIds);

    /**
     * 获取顶级分类
     *
     * @param pdtIds 大类ids
     * @return 顶级分类
     */
    List<MaterialProductDO> getTopCategoriesByPdtIds(List<Long> pdtIds);

    /**
     * 检查是否是检定的分类
     *
     * @param productId 大类id
     * @return 是否是审核的分类
     */
    Boolean checkIsVerifyCategoryByPdtId(Long productId);

    /**
     * 根据pdtCodes获取大类数据
     *
     * @param pdtCodes pdtCodes
     * @return 物料数据
     */
    List<MaterialProductDO> getProductListByPdtCodes(List<String> pdtCodes);

    /**
     * 根据编码和规格获取物料数据
     *
     * @param codes 编码列表
     * @param specifications 规格列表
     * @return 物料数据
     */
    List<MaterialProductDO> getProductListByCodeAndSpec(List<String> codes, List<String> specifications);


    List<MaterialProductDO> selectListWithCustomSql(MaterialProductPageReqVO reqVO);

    List<Long> getIdListByIdPath(Long id);

    List<MaterialProductDO> listByIdPath(Long id, String nodeType);
}